/* db_types.h - type definitions for a simple virtual machine
 *
 * Copyright (c) 2011 by David Michael Betz.  All rights reserved.
 *
 */

#ifndef __DB_TYPES_H__
#define __DB_TYPES_H__

#include <stdint.h>

#define VMTRUE		1
#define VMFALSE   	0

typedef int32_t VMVALUE;
typedef uint32_t VMUVALUE;

#define RAMSIZE             (8 * 1024)
#define MAX_OBJECTS         32

int strcasecmp(const char *s1, const char *s2);

#define ALIGN_MASK				(sizeof(VMVALUE) - 1)

#define FLASH_SPACE

#define VMCODEBYTE(p)           *(uint8_t *)(p)
#define VMINTRINSIC(i)          Intrinsics[i]

#endif
