#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include "propeller.h"
#include "db_vm.h"

void VM_sysinit(int argc, char *argv[])
{
}

void VM_getline(char *buf, int size)
{
	fgets(buf, size, stdin);
}

void VM_vprintf(const char *fmt, va_list ap)
{
    char buf[80], *p = buf;
    vsprintf(buf, fmt, ap);
    while (*p != '\0')
        VM_putchar(*p++);
}

void VM_putchar(int ch)
{
	putchar(ch);
}

VMVALUE VM_getreg(int index)
{
    VMVALUE value = 0;
    switch (index) {
    case RG_CNT:
        value = CNT;
        break;
    case RG_DIRA:
        value = DIRA;
        break;
    case RG_OUTA:
        value = OUTA;
        break;
    case RG_INA:
        value = INA;
        break;
    case RG_CLKFREQ:
        value = CLKFREQ;
        break;
    }
	return value;
}

void VM_setreg(int index, VMVALUE value)
{
    switch (index) {
    case RG_DIRA:
        DIRA = value;
        break;
    case RG_OUTA:
        OUTA = value;
        break;
    }
}

int strcasecmp(const char *s1, const char *s2)
{
    while (*s1 != '\0' && (tolower(*s1) == tolower(*s2))) {
        ++s1;
        ++s2;
    }
    return tolower((unsigned char) *s1) - tolower((unsigned char) *s2);
}
